SystemOrganization addCategory: #'Mondrian-Example'!
SystemOrganization addCategory: #'Mondrian-Example-Tests'!

Object subclass: #DistributionMapExample
	instanceVariableNames: 'propertiesMap propertyBlock elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Example'!

!DistributionMapExample classSide methodsFor: 'public' stamp: 'Alexandre.Bergel 4/20/2009 19:06'!
openOn: classes

	^ (self new render: classes) open! !

!DistributionMapExample classSide methodsFor: 'example' stamp: 'AlexandreBergel 5/18/2011 19:38'!
sample

	(self new properties: self sampleProperties;
				propertiesMap: self sampleMap;
				propertyBlock: self sampleBlock;
				elements: self sampleOrderedElements;
				render: Collection withAllSubclasses
				)
				open! !

!DistributionMapExample classSide methodsFor: 'example' stamp: 'simon.denier 4/19/2009 20:21'!
sampleBlock
	"should extend Dictionary to make a switch control structure"
	
	^ [ :method ||numArgs|
			numArgs := method numArgs.
			(numArgs = 0)  ifTrue: [ #unary ]
								ifFalse: [
									(numArgs = 1) ifTrue: [ #binary ]
													 ifFalse: [ #keywords ]
												]]! !

!DistributionMapExample classSide methodsFor: 'example' stamp: 'simon.denier 4/19/2009 20:15'!
sampleElements

	^ #methods! !

!DistributionMapExample classSide methodsFor: 'example' stamp: 'simon.denier 4/19/2009 20:33'!
sampleMap

	^ Dictionary with: (#unary -> Color white) with: (#binary -> Color gray) with: (#keywords -> Color black)! !

!DistributionMapExample classSide methodsFor: 'example' stamp: 'simon.denier 4/19/2009 20:56'!
sampleOrderedElements

	^ [:class ||dic orderedMethods|
			orderedMethods := OrderedCollection new.
			dic := Dictionary new.
			self sampleProperties do: [:prop | dic at: prop put: OrderedCollection new].
			class methods do: [ :mth|
				(dic at: (self sampleBlock value: mth)) add: mth
				].
			self sampleProperties do: [:prop |
				orderedMethods addAll: (dic at: prop)
				].
			orderedMethods
		]! !

!DistributionMapExample classSide methodsFor: 'example' stamp: 'simon.denier 4/19/2009 20:05'!
sampleProperties

	^ #(#unary #binary #keywords)! !

!DistributionMapExample methodsFor: 'accessing' stamp: 'Alexandre.Bergel 4/20/2009 19:06'!
colorAtIndex: anInteger
	"Maybe some colors are duplicated. But does it really make sense to have a large amonts of different properties?"

	^ (anInteger <= Color strongColors size)
		ifTrue: [ Color strongColors at: anInteger ]
		ifFalse: [ Color indexedColors at: anInteger ]
		! !

!DistributionMapExample methodsFor: 'accessing' stamp: 'simon.denier 4/19/2009 19:49'!
colorForElement: element

	^ self propertiesMap at: (self propertyBlock value: element)! !

!DistributionMapExample methodsFor: 'accessing' stamp: 'simon.denier 4/19/2009 19:52'!
elements: aSymbolOrBlock

	elements := aSymbolOrBlock ! !

!DistributionMapExample methodsFor: 'accessing' stamp: 'simon.denier 4/19/2009 19:56'!
elementsFor: aContainer

	^ elements moValue: aContainer! !

!DistributionMapExample methodsFor: 'accessing' stamp: 'Alexandre.Bergel 4/20/2009 19:02'!
properties: aCollectionOfProperties

	| map |
	map := self propertiesMap.
	1 to:aCollectionOfProperties size do: [ :i |
		map add: ((aCollectionOfProperties at: i) -> (self colorAtIndex: i + 1))
		].
	^ map! !

!DistributionMapExample methodsFor: 'accessing' stamp: 'simon.denier 4/19/2009 19:40'!
propertiesMap

	^ propertiesMap ifNil: [ propertiesMap := Dictionary new]! !

!DistributionMapExample methodsFor: 'accessing' stamp: 'simon.denier 4/19/2009 20:23'!
propertiesMap: aDictionary

	propertiesMap := aDictionary! !

!DistributionMapExample methodsFor: 'accessing' stamp: 'AlexandreBergel 5/18/2011 11:26'!
propertyBlock

	^ propertyBlock! !

!DistributionMapExample methodsFor: 'accessing' stamp: 'Alexandre.Bergel 8/30/2009 13:54'!
propertyBlock: oneParameterBlock

	propertyBlock := oneParameterBlock ! !

!DistributionMapExample methodsFor: 'public-view rendering' stamp: 'AlexandreBergel 5/18/2011 19:38'!
render: classes
	"(DistributionMapExample new render: Collection withAllSubclasses) open"
	"broken"
	| nodes view |
	nodes := classes.

	view := MOViewRenderer new.
	view interaction nodraggable.
	view interaction popupText.
	view nodes: nodes forEach: [ :node |
		view interaction nodraggable.
		view interaction popupText: [:el| el selector].
		view shape: (
			MORectangleShape new size: 10 ;
				fillColor: [:el | self colorForElement: el];
				yourself
		).
		view nodes: (self elementsFor: node).
		view layout: (MOGridLayout new gapSize: 1).
	].
	view gridLayout.

	^ view! !

Object subclass: #MOExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Example'!

MOExamples subclass: #MOEaselExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Example'!

!MOEaselExamples commentStamp: '<historical>' prior: 0!
MOEaselExamples contains many examples. They features the principal point of Mondrian.

Class collaborations
	

Class public API
		#script00NumberLinearNormalizer	#script01SimpleHighlight	#script01XKCDColors	#script02HighlightSeveralNodes	#script03HighlightSeveralNodes	#script04SizeUpdateNodes	#script05ClickingOnBackground	#script06ClickingOnBackgroundWithUpdate	#script07ComplexRendering	#script08PopupView	#script09WindowStatus	#script10OpeningNewVisualization	#script11SelectionAndDeselection	#script12MiniGUI	#script13	#script1Form	#script1NumberLinearNormalizer	#script1ScatterplotLayout	#script1SimpleNodes	#script1Subview	#script1Transparency	#script1UML	#script2ColoredNodes	#script2FormBuilder	#script2Identity	#script2SimpleScatterplotLayout	#script2Subview	#script2SystemComplexity	#script3AbstractClasses	#script3ColorWheel	#script3ColoredNodes	#script3ExplicitIdentity	#script3FlagExample	#script3InteractiveSpringLayout	#script3SubviewSingleForward	#script4CenteredColumn	#script4DistributionMap	#script4EdgesAndTitledNodes	#script4ImageShape	#script4InteractiveSpringLayout2	#script4InteractiveSubview	#script4Zoom	#script5ArrowedOrthoVerticalLineShape	#script5AsYetUnclassifiedMethodCategory	#script5Labels	#script5MinimumGridLayout	#script6EdgesToAll	#script6MOArrowedOrthoHorizontalLineShape	#script6TreeLayout	#script7AttachPoint	#script7BulletTreeLayout	#script7DashedEdge	#script7FlowLayout	#script8Sugiyama	#script9Layout	#umlShape

Testing classes
	MOEaselTest 

Comments written by AlexandreBergel on 28 April 2011
!

!MOEaselExamples classSide methodsFor: 'helpers' stamp: 'AlexandreBergel 9/5/2010 09:33'!
umlShape
	| builder |
	builder := MOFormsBuilder new.
	builder
		column;
		fill.
	builder
		row;
		fill;
		row;
		fill.
	builder x: 1 y: 1 add: MORectangleShape new.
	builder
		x: 1
		y: 1
		add:
			(((MORectangleShape new)
				withoutBorder;
				withText) text: [ :cls | cls name ]).
	builder x: 1 y: 2 add: MORectangleShape new.
	builder
		x: 1
		y: 2
		add:
			(((MORectangleShape new)
				withoutBorder;
				withText)
				text: [ :cls | cls methodDict keys inject: '' into: [ :sum :el | sum , el , (String with: Character cr) ] ]).
	^ builder shape! !

!MOEaselExamples methodsFor: 'accessing' stamp: 'AlexandreBergel 1/8/2011 00:37'!
script00NumberLinearNormalizer
	<title: 'number linear'>
	
^
'| normalizer |

normalizer := MONumberLinearNormalizer inContext: {1 . 2 . 3 . 4 . 3 . 2 . 1}. normalizer scale: 50.
view shape rectangle size: normalizer.
view nodes: {1 . 2 . 3 . 4 . 3 . 2 . 1}.

"The script above has the same effect than:
| maxPixel maxValue |
maxPixel := 50.
maxValue := 4.
view shape rectangle size: [:v | (v * maxPixel / maxValue) asInteger ].
view nodes: {1 . 2 . 3 . 4 . 3 . 2 . 1}
"'! !

!MOEaselExamples methodsFor: 'interaction' stamp: 'AlexandreBergel 9/16/2010 18:15'!
script01SimpleHighlight
	<title: 'simple highlight'>
^
'view shape rectangle size: 60.
view interaction 
	highlightWhenOver.

view nodes: (1 to: 20)'! !

!MOEaselExamples methodsFor: 'colors' stamp: 'AlexandreBergel 11/3/2010 16:44'!
script01XKCDColors
	<title: 'XKCD colors'>
	
^ '| cols |
cols := (XKCDColor colormap keys collect: [:cnam | XKCDColor named: cnam]) sortedAs: #hue.

view shape rectangle withoutBorder.
view nodes: cols forEach: [ :col | 
	view shape rectangle 
				fillColor: col; 
				width: 65; height: 25. 
	view node: col. 
	view shape label text: col name.
	view node: col. 
	
	view verticalLineLayout ].
	view gridLayout gapSize: 0'! !

!MOEaselExamples methodsFor: 'colors' stamp: 'AlexandreBergel 4/29/2011 14:49'!
script02ColorsGradient
	<title: 'Gradient colors'>

^ 'view shape rectangle withoutBorder.
view node: ''test gradient'' forIt: [
	view shape rectangle 
		size: 10;
		linearBlueFillColor: #yourself within:   (1 to: 50).
	view nodes: (1 to: 50).
].

view shape rectangle withoutBorder.
view node: ''test gradient'' forIt: [
	view shape rectangle 
		size: 10;
		linearGreenFillColor: #yourself within:   (1 to: 50).
	view nodes: (1 to: 50).
].

view shape rectangle withoutBorder.
view node: ''test gradient'' forIt: [
	view shape rectangle 
		size: 10;
		linearRedFillColor: #yourself within:   (1 to: 50).
	view nodes: (1 to: 50).
].

view shape rectangle withoutBorder.
view node: ''test gradient'' forIt: [
	view shape rectangle 
		size: 10;
		linearYellowFillColor: #yourself within:   (1 to: 50).
	view nodes: (1 to: 50).
].

view verticalLineLayout.
'! !

!MOEaselExamples methodsFor: 'interaction' stamp: 'AlexandreBergel 9/16/2010 18:15'!
script02HighlightSeveralNodes
	<title: 'highlight several nodes '>
^
'
view interaction highlightWhenOver: [:v | {v - 1 . v + 1. v + 4 . v - 4}].
view shape rectangle 
	width: 40;
	height: 30;
	withText.
view nodes: (1 to: 16).
view gridLayout gapSize: 2.'! !

!MOEaselExamples methodsFor: 'colors' stamp: 'AlexandreBergel 11/8/2011 20:38'!
script03ColorsGradient
	<title: 'Gradient colors with low and high bounds'>

^ 'view shape rectangle 
	linearFillColor: #yourself within: (1 to: 20) highColor: Color purple lowColor: Color green;
	size: 30.
view nodes: (1 to: 20).
'! !

!MOEaselExamples methodsFor: 'interaction' stamp: 'AlexandreBergel 1/8/2011 00:38'!
script03HighlightSeveralNodes
	<title: 'strong highlight several nodes '>
^
'
view interaction strongHighlightWhenOver: [:v | {v - 1 . v + 1. v + 4 . v - 4}].
view shape rectangle 
	width: 40;
	height: 30;
	withText.
view nodes: (1 to: 16).
view gridLayout gapSize: 2.'! !

!MOEaselExamples methodsFor: 'interaction' stamp: 'AlexandreBergel 9/16/2010 18:15'!
script04SizeUpdateNodes
	<title: 'variation in node size'>
^
'view shape rectangle size: 10.
view interaction
	forNodes: #yourself 
	whenEnteringUpdateShapes: [:shape | shape size: 30] 
	whenLeavingUpdateShapes: [:shape | shape size: 10]
	withLayoutUpdate: true.
view nodes: (1 to: 20).'! !

!MOEaselExamples methodsFor: 'interaction' stamp: 'AlexandreBergel 9/16/2010 18:15'!
script05ClickingOnBackground
	<title: 'Clicking on background'>
^
'view nodes: (1 to: 100).
view gridLayout.

view root interaction
	on: MOMouseDown do: [:ann | self inform: ''You clicked on the background, press ok!!'' ]'! !

!MOEaselExamples methodsFor: 'interaction' stamp: 'AlexandreBergel 9/16/2010 18:15'!
script06ClickingOnBackgroundWithUpdate
	<title: 'Clicking on background with update'>
^
'view interaction action: [:v | (view nodeForDomainValue: v) inspect ].
view nodes: (1 to: 100).
view gridLayout gapSize: 10.

view root interaction
	on: MOMouseDouble do: [:ann | 
			| node txt |
			
			txt := UIManager default request: ''Enter a text''.
			view shape rectangle withText.
			node := view node: txt.
			node translateBy: ann position.
			view updateWindow
			]'! !

!MOEaselExamples methodsFor: 'interaction' stamp: 'AlexandreBergel 9/16/2010 18:15'!
script07ComplexRendering
	<title: 'Mouse over and node expansion'>
^
'view shape rectangle size: 20.
view interaction action: #inspect.
view interaction 
	whenEnteringUpdateNode: [:node | 
		view interaction forwarder.
		view nodes: (Set allSubclasses).
			view interaction forwarder.
		view edgesFrom: #superclass..
		view treeLayout
		] 
	whenLeavingUpdateNode:  [:node | ]  
	withLayoutUpdate: true.
view nodes: (1 to: 3)'! !

!MOEaselExamples methodsFor: 'interaction' stamp: 'AlexandreBergel 9/16/2010 18:15'!
script08PopupView
	<title: 'Popup view'>
^
'view shape rectangle size: 60.
view interaction 
	popupView: [:entity :myView | myView nodes: (1 to: 20) ] delay: 500;
	highlightWhenOver.

view nodes: (1 to: 20)'! !

!MOEaselExamples methodsFor: 'interaction' stamp: 'AlexandreBergel 9/16/2010 18:15'!
script09WindowStatus
	<title: 'Window status'>
^
'view shape rectangle size: 30.
view interaction windowStatus: #yourself.
view nodes: (1 to: 5)'! !

!MOEaselExamples methodsFor: 'shape' stamp: 'AlexandreBergel 1/9/2012 12:05'!
script10LabelAbove
	<title: 'Labelled nodes'>
	
^ '
view shape rectangle withoutBorder.
view nodes: Collection withAllSubclasses forEach: [ :cls |
	view interaction forward.
	view shape label.
	view node: cls.

	view interaction forward.
	view node: cls forIt: [ view nodes: cls methods. view gridLayout gapSize: 2 ].
	view verticalLineLayout center gapSize: 0
].

view edgesFrom: #superclass.
view treeLayout'! !

!MOEaselExamples methodsFor: 'interaction' stamp: 'AlexandreBergel 9/16/2010 18:23'!
script10OpeningNewVisualization
	<title: 'Opening new visualization'>
^
'
"An event handler may contain any piece of code, including a definition of a new view.
It will be executed each time the corresponding event is triggered. "

view shape label.
view node: ''Double click on a node to open a new window''.
view shape rectangle size: 30; withText; fontSize: 15.

view interaction on: MOMouseDouble do: [ :ann | 
	| secondView |
	secondView := MOViewRenderer title: ''Second view''.
	secondView shape rectangle size: 10.
	secondView nodes: (1 to: (ann model * ann model) ).
	secondView gridLayout lineItemsCount: [ :v | ann model].
	secondView open
	].

view nodes: (1 to: 5).
view flowLayout 
'! !

!MOEaselExamples methodsFor: 'interaction' stamp: 'AlexandreBergel 9/16/2010 18:22'!
script11SelectionAndDeselection
	<title: 'Selecting multiple nodes'>
^
'view shape label.
view node: ''Click on inner nodes''.
view nodes: (1 to: 3) forEach: [:each |
	|nodes |
	nodes :=  (each * 100) to: (each * 110).
	view interaction 
		registerForEvent: MOElementSelection
		forNodes: [:v | nodes ]
		updateShape: [:shape | shape borderColor: Color red]
		updateLayout: false.
	view interaction 
		registerForEvent: MOElementDeselection
		forNodes: [:v | nodes ]
		updateShape: [:shape | shape borderColor: Color black]
		updateLayout: false.
	view nodes: nodes.
].
view verticalLineLayout'! !

!MOEaselExamples methodsFor: 'interaction' stamp: 'AlexandreBergel 9/16/2010 18:51'!
script12MiniGUI
	<title: 'Button'>
^
'
"Combining event handlers, global variables with window refreshing may simulate rudimentary graphical user interface"

| value |
value := 0.

view shape rectangle
	width: 50;
	disableCache;
	text: [:v | value ]; 
	fontSize: 20.
view node: ''counter''.

view interaction on: MOMouseDouble do: [ :v | value := value + 10 ].
view interaction on: MOMouseDown do: [ :v | value := value + 1 ].
view interaction on: MOEvent do: [ :v | view updateWindow ].

view node: ''button'' forIt: [
	view shape label.
	view interaction forward.
	view node: ''press once to add 1'', String cr, ''double click to add 10''.
]
'! !

!MOEaselExamples methodsFor: 'interaction' stamp: 'AlexandreBergel 7/12/2011 23:37'!
script13Popup
	<title: 'Popup'>
^
'"Popup may be easily disabled"

view interaction noPopup.
view shape label.
view node: ''with no popup''.

view shape label.
view node: ''with a popup''.
'! !

!MOEaselExamples methodsFor: 'interaction' stamp: 'AlexandreBergel 6/14/2011 12:24'!
script14AddingLines
	<title: 'Lines'>
^
'view node: ''node'' forIt: [
	view interaction
				whenEnteringUpdateNode: [ :aValue | 
					view edges: {aValue}  from: #yourself toAll: ((1 to: 9) copyWithout: aValue )  ].

	view shape rectangle size: 30.
	view nodes: (1 to: 9).
	view gridLayout gapSize: 10.
]
'! !

!MOEaselExamples methodsFor: 'interaction' stamp: 'AlexandreBergel 7/12/2011 23:38'!
script14ChangingShape
	<title: 'Changing color on click'>
^
'" Clicking on Node 1 will turn Node 2 red. And the other way around"

| shape1 shape2 |
shape1 := MORectangleShape new size: 20; disableCache; withText.
shape2 := MORectangleShape new size: 20; disableCache; withText.

(1 to: 5) do: [ :arg | 
	view shape: shape1. 
	view interaction on: MOMouseDown do: [:ann | 
		shape1 fillColor: Color white.
		shape2 fillColor: Color red. 
		view updateWindow].
	view node: 1 ].

(1 to: 5) do: [ :arg | 
	view shape: shape2. 
	view interaction on: MOMouseDown do: [:ann | 
		shape2 fillColor: Color white.
		shape1 fillColor: Color red. 
		view updateWindow].
	view node: 2].
'! !

!MOEaselExamples methodsFor: 'interaction' stamp: 'AlexandreBergel 12/4/2011 11:05'!
script15UpdatingEdgeShape
	<title: 'Updating edge shape'>
^
'"Example on updating shape color. Moving the mouse about a node turn the edges to used classes red. "

| classes edges getDepOfAClass classesAndTheirOutgoingEdges |

"Return the list of classes that are dependent from aClass"
getDepOfAClass := [ :aClass |
	| b |
	b := Set new.
	aClass methods do: [:m | b addAll: ((m allLiterals select: [:l | (l isKindOf: Association) and: [ l value isBehavior ]]) collect: #value) ].
	b ].

"We select all the classes of Mondrian"
classes := (Smalltalk globals select: #isBehavior) select: [:c | c name beginsWith: ''MO'' ].
view shape rectangle width: #numberOfAttributes; height: #numberOfMethods.
view interaction action: #inspect.
view interaction
	on: MOMouseEnter do: [ :ann | 
		(classesAndTheirOutgoingEdges at: ann model) do: [:e | e copyShapeAndDo: [:s | s color: Color red ]].
		 ];
	on: MOMouseLeave do: [ :ann | 
		(classesAndTheirOutgoingEdges at: ann model) do: [:e | e copyShapeAndDo: [:s | s color: Color lightGray ]].
		 ].
view nodes: classes.
 
view shape: (MOOrthoVerticalLineShape new color: Color black).
edges := view edgesFrom: #superclass.
view treeLayout userDefinedEdges: edges.

view shape line color: Color veryLightGray.

classesAndTheirOutgoingEdges := Dictionary new.
classes do: [:cls |
	classesAndTheirOutgoingEdges at: cls put: (view edge: cls from: #yourself toAll:  [:c | getDepOfAClass value: c ])
].

'! !

!MOEaselExamples methodsFor: 'interaction' stamp: 'AlexandreBergel 1/16/2012 10:52'!
script16RememberingPosition
	<title: 'Remembering node position'>
^
'"This example illustrates the use of attributes for each node to store some information, such as the position"
view interaction item: ''Fix position'' action: [:element | 
	| mondrianNode |
	"We get the monode that correspond to what I click on"
	mondrianNode := view nodeForDomainValue: element.
	
	mondrianNode attributeAt: #fixedPosition put: mondrianNode position.
].
view shape rectangle size: 15.
view nodes: Collection withAllSubclasses.
view edgesFrom: #superclass.
view treeLayout.

view root interaction item: ''Return to fixed position'' action: [:root | 
	view root applyLayout.
	view root nodesDo: [:n | 
		(n hasAttribute: #fixedPosition) 
			ifTrue: [ n translateTo: (n attributeAt: #fixedPosition)] ]
]
'! !

!MOEaselExamples methodsFor: 'interaction' stamp: 'BenComan 6/10/2012 02:54'!
script17RubberBand
	<title: 'Drag a rubber band between nodes'>
^
'"This example illustrates the use of a rubber band to interactive define connections between nodes"
"Try dragging lines between different combinations of colored squares, and moving them around."

view interaction rubberBandFromMe.
view shape rectangle withText; size: 20; borderColor: Color blue.
view nodes: (1 to: 4).

view interaction rubberBandReceiveDrop: [ :source :target | view addEdgeFromNode: source toNode: target ].
view interaction noPopup.
view shape rectangle withText; size: 20.
view nodes: (5 to: 9).

view circleLayout.

'! !

!MOEaselExamples methodsFor: 'builder' stamp: 'AlexandreBergel 9/16/2010 01:35'!
script1Form
	<title: 'form: facility'>
^ '
"form: takes a one block argument. A forms builder is passed as argument"
view shape 
	form: [:b | 
					b column; fill; row; fill; row; fill; row; fill. 
					b x:1 y:1 add: (MORectangleShape new fillColor: Color lightGreen).
					b x:1 y:2 add: MORectangleShape new withText.
					b x:1 y:3 add: (MORectangleShape new fillColor: Color lightBlue).].
view node: ''hello world'''! !

!MOEaselExamples methodsFor: 'normalizer' stamp: 'AlexandreBergel 1/7/2011 23:50'!
script1NumberLinearNormalizer
	<title: 'number linear'>
	
^
'| normalizer |

normalizer := MONumberLinearNormalizer inContext: {1 . 2 . 3 . 4 . 3 . 2 . 1}. normalizer scale: 50.
view shape rectangle size: normalizer.
view nodes: {1 . 2 . 3 . 4 . 3 . 2 . 1}.

"The script above has the same effect than:
| maxPixel maxValue |
maxPixel := 50.
maxValue := 4.
view shape rectangle size: [:v | (v * maxPixel / maxValue) asInteger ].
view nodes: {1 . 2 . 3 . 4 . 3 . 2 . 1}
"'! !

!MOEaselExamples methodsFor: 'layout' stamp: 'JeanRemyFalleri 7/15/2010 19:35'!
script1ScatterplotLayout

^ '
| nodes mthNorm locNorm |
nodes := Collection withAllSubclasses.
mthNorm := MONumberLinearNormalizer inContext: nodes withCommand: [:c | c selectors size].
mthNorm scale: 10.
locNorm := MONumberLinearNormalizer inContext: nodes withCommand: [:c | c linesOfCode].
locNorm scale: 10.
view node: #plot forIt: [
	view nodes: (nodes collect: [:c| {c name. mthNorm moValue: c. locNorm moValue: c}]).
	view interaction popupText: [:n | n first].
	view layout: (MOScatterplotLayout new
							upSideDown;
							offset: 2;
							scaleFactor: 10;
							x: #third;
							y: #second)].
'! !

!MOEaselExamples methodsFor: 'basic' stamp: 'Alexandre Bergel 12/17/2009 02:14'!
script1SimpleNodes
	<title: 'just 20 simple nodes'>
	^
 '
"Display 20 nodes using the default size (5x5)"
view nodes: (1 to: 20).
'! !

!MOEaselExamples methodsFor: 'subviews' stamp: 'AlexandreBergel 9/16/2010 18:30'!
script1Subview
	<title: 'simple'>
^
'"Each node may itself be a container of a subview.
Views may be easily nested. Such a ''subview'' may be rendered according to 
the encapsulating node"

view nodes: (1 to: 5) forEach: [:each |
	view nodes: (1 to: each).
	view gridLayout
].

"A subview may be defined for one single node as well"

view node: ''outter node'' forIt: [
	view shape label.
	view node: ''inner node''
]'! !

!MOEaselExamples methodsFor: 'shape' stamp: 'Alexandre Bergel 5/12/2010 08:46'!
script1Transparency
	<title: 'color transparency'>
	
^ 'view shape ellipse
	width: 100; height: 100; fillColor:(Color blue alpha:0.2).
view nodes: #((10 10) (10 20) (0 0) (40 20)).
view layout: (MOScatterplotLayout new
                      scaleFactor: 5;
                      x: #first;
                      y: #second).

view shape line
	fromPositions: #(#center);
	toPositions: #(#center).
view edge: #(10 10) from: #yourself to:  #(10 20).
view edge: #(40 20) from: #yourself to:  #(10 20).'! !

!MOEaselExamples methodsFor: 'software visualization' stamp: 'AlexandreBergel 9/13/2011 16:02'!
script1UML
	<title: 'UML'>
^'
"Resize the easel after generating"
view shape umlClass.
view nodes: (MOShape withAllSubclasses) forEach: [:cls | 
	view shape label.
	view nodes: (cls methods collect: #selector).
	view verticalLineLayout ].

view shape: (MOArrowedOrthoVerticalLineShape new).
view edgesFrom: #superclass.
view treeLayout'! !

!MOEaselExamples methodsFor: 'basic' stamp: 'AlexandreBergel 9/16/2010 19:03'!
script2ColoredNodes
	<title: 'colored nodes'>
	^
'
"Gradient color may be easily associated to a shape using linearFillColor:within:.
Variant of this message get colored fading. "

view shape rectangle withoutBorder.
view node: #foo forIt: [
	view shape rectangle
		withoutBorder;
		size: 30;
		linearFillColor: #yourself within: (1 to: 10).
	view nodes: (1 to: 10) ].
	

view shape rectangle withoutBorder.
view node: #foo forIt: [
	view shape rectangle
		size: 30;
		withoutBorder;
		linearRedFillColor: #yourself within: (1 to: 10).
	view nodes: (1 to: 10) reversed ].
	

view shape rectangle withoutBorder.
view node: #foo forIt: [
	view shape rectangle
		withoutBorder;
		size: 30;
		linearGreenFillColor: #yourself within: (1 to: 10).
	view nodes: (1 to: 10) reversed  ].
	

view shape rectangle withoutBorder.
view node: #foo forIt: [
	view shape rectangle
		size: 30;
		withoutBorder;
		linearBlueFillColor: #yourself within: (1 to: 10).
	view nodes: (1 to: 10) ].
	
view verticalLineLayout gapSize: 4
'! !

!MOEaselExamples methodsFor: 'builder' stamp: 'AlexandreBergel 9/16/2010 01:35'!
script2FormBuilder
	<title: 'example of MOFormsBuilder'>
^ '
| builder rectangleShape |
builder := MOFormsBuilder new.
builder column; left; pref.
builder row; left; row; left; row; left; pref.

rectangleShape := MORectangleShape new
		height: 10;
		width: 20.

builder x: 1 y: 1 add: (rectangleShape copy fillColor: Color red).
builder x: 1 y: 2 add: (rectangleShape copy fillColor: Color green).
builder x: 1 y: 3 add: (MORectangleShape new withText).

view shape: builder shape.
view nodes: (1 to: 5).
view treeLayout
'! !

!MOEaselExamples methodsFor: 'normalizer' stamp: 'AlexandreBergel 1/7/2011 23:51'!
script2Identity
	<title: 'identity normalizer'>
	
^
'| normalizer |

normalizer := MONIdentityNormalizer new.
view shape rectangle size: 30; fillColor: normalizer.
view nodes: (1 to: 30) , (30 to: 1).
'! !

!MOEaselExamples methodsFor: 'layout' stamp: 'Alexandre Bergel 3/2/2010 21:52'!
script2SimpleScatterplotLayout
	<title: 'simple scatterplotlayout'>

^ 'view nodes: #((10 5) (20 50) (2 4) (60 20)).
view layout: (MOScatterplotLayout new
						upSideDown;
						scaleFactor: 2;
						x: #first;
						y: #second).'! !

!MOEaselExamples methodsFor: 'subviews' stamp: 'AlexandreBergel 9/16/2010 18:40'!
script2Subview
	<title: 'forwarder '>
^
'"Events received by an inner node may be forwarded to its encapsulating node using the forward message sent to an announcer."

view shape rectangle withoutBorder.
view nodes: {''forwarder''} forEach: [ :each |
	view shape label.
	view node: each.
	
	view interaction forward.
	view node: each forIt: [
		view shape label.
		view interaction forward.
		view node: ''drag me!!''
	].
	view verticalLineLayout center.
].


view shape rectangle withoutBorder.
view nodes: {''no forwarder''} forEach: [ :each |
	view shape label.
	view node: each.
	
	view node: each forIt: [
		view shape label.
		view node: ''drag me!!''
	].
	view verticalLineLayout center.
]


'! !

!MOEaselExamples methodsFor: 'software visualization' stamp: 'AlexandreBergel 5/18/2011 13:06'!
script2SystemComplexity
	<title: 'System Complexity'>
^
'"Each node is a class, edges designate inheritance.
Height is linear to the number of method the class defines.
Width is linear to the number of variables the class defines.
Color color is linear to the number of lines of code of the class.
The darkest node designates the class that has the highest number of lines of code"

view shape rectangle
	width: [:cls | cls instVarNames size * 3];
	height: [:cls | cls methods size ];
	linearFillColor: [:cls | cls methods inject: 0 into: [:sum :el | sum + el getSource lineCount]] within: Collection withAllSubclasses.
view nodes: Collection withAllSubclasses.
view edgesFrom: #superclass.
view treeLayout'! !

!MOEaselExamples methodsFor: 'software visualization' stamp: 'AlexandreBergel 1/24/2011 23:41'!
script3AbstractClasses
	<title: 'Abstract classes'>
	
^ 
'
"Intense red represents abstract classes that define one or more abstract methods. Bright red shows abstract classes that do not define abstract methods (only via inheritance). 
No leaf class must be abstact."

| packages classes |
packages := PackageInfo allPackages select: [ :p | p packageName beginsWith: ''Mondrian-''  ].
classes := OrderedCollection new.
packages do: [ :p | classes addAll: (p classes reject: #isTrait) ].

view shape rectangle
	width: [ :each | each instVarNames size * 3];
	height: [ :each | each methods size ];
	if: #isAbstractClass fillColor: Color lightRed;
	if: [:cls | cls methods anySatisfy: #isAbstract] fillColor: Color red.
	
view interaction 
	action: #browse;
	item: ''inherited abstract methods'' action: 
		[ :cls | (((cls allMethods, cls class allMethods ) select: #isAbstract) collect: #selector) inspect ].
view nodes: classes.

view edgesFrom: #superclass.

view treeLayout.
'
! !

!MOEaselExamples methodsFor: 'shape' stamp: 'AlexandreBergel 10/26/2010 11:39'!
script3ColorWheel
	<title: 'color wheels'>
	
^ '"Demonstration of color wheels. 

*Note that this functionality is offered by Pharo, and not directly by Mondrian
"
| colors |
colors := (Color red wheel: 6) asOrderedCollection.
"A new wheel, a bit darker this time"
colors addAll: ((Color red adjustBrightness: -0.5) wheel: 6).

(1 to: 12) do: [:arg|
	view shape rectangle 
		size: 20;
		fillColor: (colors at: arg).
	view node: arg].'! !

!MOEaselExamples methodsFor: 'basic' stamp: 'AlexandreBergel 9/16/2010 19:09'!
script3ColoredNodes
	<title: 'Ellipse, triangle and diamond'>
	^
'"The default node shape is a rectangle. Other primitive shapes may be used."

view shape rectangle withoutBorder.
view node: #ellipse forIt: [
	view shape ellipse
		height: [:each | each * 2];
		width: [:each | each * 3];
		withoutBorder;
		linearFillColor: #yourself within: (1 to: 10).
	
	view nodes: (1 to: 10)].


view shape rectangle withoutBorder.
view node: #triangle forIt: [
	view shape triangle
		height: [:each | each * 2];
		width: [:each | each * 3];
		withoutBorder;
		linearRedFillColor: #yourself within: (1 to: 10).
	
	view nodes: (1 to: 10)].

view shape rectangle withoutBorder.
view node: #diamond forIt: [
	view shape diamond
		height: [:each | each * 2];
		width: [:each | each * 3];
		withoutBorder;
		linearBlueFillColor: #yourself within: (1 to: 10).
	
	view nodes: (1 to: 10) ].

view verticalLineLayout '! !

!MOEaselExamples methodsFor: 'normalizer' stamp: 'AlexandreBergel 1/7/2011 23:52'!
script3ExplicitIdentity
	<title: 'explicit identity normalizer'>
	
^
'| normalizer |

normalizer :=  MONExplicitIdentityNormalizer
					withCommand: #yourself
					withColors: {Color blue . Color white . Color red} 
					withDefaultColor: Color pink.			
view shape rectangle size: 30; fillColor: normalizer.
view nodes: (5 to: 10).
'! !

!MOEaselExamples methodsFor: 'builder' stamp: 'AlexandreBergel 9/16/2010 01:38'!
script3FlagExample
	<title: 'flag example'>
^ '
| builder |
builder := MOFormsBuilder new.
"Assuming you want a grid made up of 3 columns and 2 rows"
builder 
	column; fill; 
	column; fill; center; 
	column; fill.
builder 
	row; fill; row; fill; row; fill;  "For the German flag"
	row; center; 							"The EU text"
	row; pref.	 "For the French flag"
"We draw a German flag"
builder x: 1 y: 1 w: 3 add: (MORectangleShape new width: 30; height: 7; fillColor: Color black).
builder x: 1 y: 2 w: 3 add: (MORectangleShape new width: 30; height: 7; fillColor: Color red).
builder x: 1 y: 3 w: 3 add: (MORectangleShape new width: 30; height: 7; fillColor: Color yellow).

builder x: 1 y: 4 w: 3 add: (MORectangleShape new text: [:aNumber |''EU '', aNumber printString]).

"We draw a French flag"
builder x: 1 y: 5 add: (MORectangleShape new width: 10; height: 20; fillColor: Color blue).
builder x: 2 y: 5 add: (MORectangleShape new width: 10; height: 20; fillColor: Color white).
builder x: 3 y: 5 add: (MORectangleShape new width: 10; height: 20; fillColor: Color red).



view interaction popupText: [:aNumber | ''my value is '', aNumber printString ].

view shape: (builder shape).
view nodes: (1 to: 27).
view edges: (1 to: 27) from: #yourself to: [:each | each * each].
view circleLayout.
'! !

!MOEaselExamples methodsFor: 'interactive layout' stamp: 'AlexandreBergel 9/16/2010 01:55'!
script3InteractiveSpringLayout
	<title: 'interactive springLayout'>

^ 'view interaction refreshLayoutEvery: 30.
view shape rectangle withText.
view nodes: Collection withAllSubclasses.
view edgesFrom: #superclass.
view layout: (MOSpringLayout new maxSecondsToCompute: 0)'! !

!MOEaselExamples methodsFor: 'subviews' stamp: 'AlexandreBergel 9/16/2010 18:40'!
script3SubviewSingleForward
	<title: 'adding subview '>
^
'view shape rectangle size: 20.
view interaction
	on: MOMouseDown do: [:ann | view forNode: ann element model do: [ view nodes: (1 to: 5). view gridLayout ] ].
view nodes: ( 1 to: 16 ).
view gridLayout'! !

!MOEaselExamples methodsFor: 'builder' stamp: 'AlexandreBergel 4/18/2011 15:50'!
script4CenteredColumn
	<title: 'centered column'>
^ '"Centered column"
"Centered column"
view shape form: [:b |
	b column; pref; center;
			row; fill;
			row; fill.
	b x:1 y:1 add: (MORectangleShape new withText; withoutBorder).
	b x:1 y:2 add: (MOChildrenShape new) ].
view nodes: #(''very very large column'' ''small'') forEach: [ :each |
	view nodes: #(1 2 3 4) ].
 '! !

!MOEaselExamples methodsFor: 'software visualization' stamp: 'AlexandreBergel 5/18/2011 13:07'!
script4DistributionMap
	<title: 'DistributionMap'>
	
^ 
'"Simple example of a distribution map. 
Green methods are short. Orange are long. Red are very long"

| classes d |
d := IdentityDictionary new.
classes := Collection withAllSubclasses.
classes do: [:aClass | aClass methods do: [:m | d at: m put: m getSource lineCount ] ].

view shape rectangle withoutBorder.
view nodes: classes forEach: [ :each |
	view shape label.
	view node: each.
	view node: each forIt: [
		view shape rectangle size: 12;
			if: [:m | (d at: m) < 5 ] fillColor: Color green;
			if: [:m | (d at: m) >= 5 and: [ (d at: m) < 25 ] ] fillColor: Color orange;
			if: [:m | (d at: m) >= 25 ] fillColor: Color red.
		view nodes: (each methods sortedAs: [:m | (d at: m) ]).
		view gridLayout gapSize: 2 ].
		view verticalLineLayout ].
	
view gridLayout
'
! !

!MOEaselExamples methodsFor: 'basic' stamp: 'Alexandre Bergel 12/17/2009 16:17'!
script4EdgesAndTitledNodes
	<title: 'edges + titled nodes'>
	^
'
| nodes |
view shape rectangle
	width: 40;
	text: #yourself.
	
nodes := view nodes: (1 to: 20).

view shape arrowedLine.
view edges: (2 to: 20) from: 1 to: #yourself.
view layout: (MOCircleLayout forNodes: nodes allButFirst)
'! !

!MOEaselExamples methodsFor: 'basic' stamp: 'VeronicaUquillas 7/20/2011 10:50'!
script4EdgesWithLabels
	<title: 'labels in edges'>
	^
'
view nodes: {OrderedCollection . SortedCollection . TSortable}.
view interaction 
		popupText: [ :from :to| from asString, '' is superclass of '', to asString ].
view edgesFrom: #superclass.	
view interaction 
		popupText: [ :from :to| to asString, '' uses '', from asString ].
view edges: {TSortable}
		from: [ :trait | trait ] 
		toAll: [ :trait | trait users asOrderedCollection ]
		using: (view shape dashedLine).
view treeLayout.
 '! !

!MOEaselExamples methodsFor: 'basic' stamp: 'VeronicaUquillas 1/3/2012 14:39'!
script4EdgesWithPopupView
	<title: 'popup view on edges'>
	^
'
view nodes: {OrderedCollection . Interval . SequenceableCollection}.
view interaction 
	popupView: [ :from :to :myView | 
		myView nodes: {from . to}.
		myView edgesFrom: #superclass ].
view edgesFrom: #superclass.	
view horizontalTreeLayout '! !

!MOEaselExamples methodsFor: 'shape' stamp: 'AlexandreBergel 12/21/2010 14:09'!
script4ImageShape
	<title: 'image'>
	
^ '"An image may be used as a shape"

MondrianIcons icons associationsDo: [ :assoc |
	view shape image form: assoc value.
	view node: assoc key
]
'! !

!MOEaselExamples methodsFor: 'interactive layout' stamp: 'AlexandreBergel 9/16/2010 01:55'!
script4InteractiveSpringLayout2
	<title: 'interactive springLayout, small example'>

^ 'view interaction refreshLayoutEvery: 30.
view shape rectangle size: 15.
view nodes: (1 to: 30).
view edges: (1 to: 30) from: #yourself to: [:v | v \\ 5].
view layout: (MOSpringLayout new maxSecondsToCompute: 0)'! !

!MOEaselExamples methodsFor: 'subviews' stamp: 'BenComan 4/9/2012 15:04'!
script4InteractiveSubview
	<title: 'adding subview interactively '>
^
'	view shape rectangle size: 20.
	view interaction 
    		whenClickingUpdateNode: 
		[ :value | 
			view forNode: value do: 
			[ 	view nodes: (1 to: 5). 
				view gridLayout.
			]
		] 
		withLayoutUpdate: true.
	view nodes: ( 1 to: 16 ).
	view gridLayout.
'! !

!MOEaselExamples methodsFor: 'normalizer' stamp: 'AlexandreBergel 6/26/2011 18:15'!
script4LowerBoundNormalizer
	<title: 'lower bound normalizer'>
	
^
'"Color normalizer use white as the lower bound. But it could be any color"

| n |
n := (1 to: 10).
view shape rectangle size: 30;
	fillColor: (MONColorLinearNormalizer 
				inContext: n lowColor: Color gray highColor: Color black).
	
view nodes: n'! !

!MOEaselExamples methodsFor: 'subviews' stamp: 'AlexandreBergel 9/16/2010 18:56'!
script4Zoom
	<title: 'Zoomed in popup view'>
^ 
'"Popup view may be zoomed in"

view shape rectangle size: 10.

view interaction popupView: [:el :v | 
	v node: ''foo'' forIt: 
	 [v nodes: (1 to: 9). v gridLayout]
] zoomedInBy: #yourself.

view nodes: (1 to: 5) forEach: [:each | 
	view nodes: (1 to: 9). view gridLayout].

view gridLayout
'! !

!MOEaselExamples methodsFor: 'shape' stamp: 'AlexandreBergel 12/30/2010 10:27'!
script5ArrowedOrthoVerticalLineShape
	<title: 'Arrowed ortho vertical line shape'>
	
^ 'view nodes: Collection withAllSubclasses.
view shape: (MOArrowedOrthoVerticalLineShape new).
view edgesFrom: #superclass.
view treeLayout'! !

!MOEaselExamples methodsFor: 'software visualization' stamp: 'AlexandreBergel 1/20/2011 10:52'!
script5AsYetUnclassifiedMethodCategory
	<title: 'As yet unclassified method category'>
	
^ 
'"This visualization is useful to track down ''as yet unclassified'' method categories. This is widely recognized as a bad Smalltlak practice to have such a method category" 

| packages classes |
packages := PackageInfo allPackages select: [ :p | p packageName beginsWith: ''Mondrian-''  ].
classes := OrderedCollection new.
packages do: [ :p | classes addAll: p classes ].

view shape rectangle 
	size: 20;
	if: [ :cls | cls organization categories includesAnyOf: #(#''as yet unclassified '' #''as yet unclassified'') ] fillColor: Color red.
	
view interaction action: #browse.
view nodes: classes.
view edgesFrom: #superclass.
view treeLayout'
! !

!MOEaselExamples methodsFor: 'basic' stamp: 'Alexandre Bergel 4/26/2010 17:04'!
script5Labels
	<title: 'labels'>
	^
'view shape rectangle withoutBorder.
view node: ''example 1'' forIt: [
	view shape label fontSize: #yourself.
	view nodes: (1 to: 40).
].

view shape rectangle withoutBorder.
view node: ''example 2'' forIt: [
	view shape label smallFont.
	view node: ''small font''.

	view shape label normalFont.
	view node: ''normal font''.

	view shape label bigFont.
	view node: ''big font''.
].

view shape rectangle withoutBorder.
view node: ''example 3'' forIt: [
	view shape label 
		linearFontSize: #yourself within: (1 to: 40).
	view nodes: (1 to: 40).
].


view verticalLineLayout'! !

!MOEaselExamples methodsFor: 'layout' stamp: 'AlexandreBergel 9/16/2010 01:47'!
script5MinimumGridLayout
	<title: 'minimum grid layout'>
	
	^'(1 to: 50) do: [ :index |
		view shape rectangle size: (200 atRandom ) ; borderWidth: 1 ; fillColor: Color lightBlue.
		view node: (index asString).
	].

	view minimumGridLayout.'! !

!MOEaselExamples methodsFor: 'subviews' stamp: 'BenComan 5/2/2012 00:40'!
script5changingSubviewLayoutInteractively
	<title: 'changing subview layout interactively '>
^
'	| b actionBlock makeMenu |

	"Define shape such that the MOLayout name is displayed above the subview children"		
	b := MOFormsBuilder new.
	b column; fill; row; fill; row; fill . 
	b x:1 y:1 add: 
	( MORectangleShape new 
		text: [ :value | (view nodeForDomainValue: value) layout. ]; 
		textAlignment: #center; 
		borderColor: Color white 
	) .
	b x:1 y:2 add: ( MORectangleShape new ) .
	b x:1 y:2 add: ( MOChildrenShape new ) .
	view shape: b shape.
	
	"Define menus for setting the layouts of subviews"
	actionBlock := 	
	[ :selectedValue :newLayout | 
		| element position | 
		element := view nodeForDomainValue: selectedValue.
		position := element bounds origin.
		element layout: newLayout.
		element applyLayout.
		element resetFormCacheUpToTheRoot.
		element translateBy: position.
		view updateWindow.
	].
	makeMenu := 
	[ :layout |
		view interaction item: (layout class name asString) action: [ :selectedValue | actionBlock value: selectedValue value: layout ].		
	].
	makeMenu value: (MOGridLayout new).	
	makeMenu value: (MOBottomFlowLayout new).
	makeMenu value: (MOBulletTreeLayout new).
	makeMenu value: (MOCircleLayout new scaleBy: 6).
	makeMenu value: (MODominanceTreeLayout new).
	makeMenu value: (MOFADELayout new).
	makeMenu value: (MOFlowLayout new).
	makeMenu value: (MOForceBasedLayout new).
	makeMenu value: (MOHorizontalDominanceTreeLayout new).
	makeMenu value: (MOFlowLayout new).
	makeMenu value: (MODominanceTreeLayout new).
	makeMenu value: (MOHorizontalLineLayout new).
	makeMenu value: (MOHorizontalNarrowTreeLayout new).
	makeMenu value: (MOHorizontalTreeLayout new).
	makeMenu value: (MOMinimumGridLayout new).
	makeMenu value: (MOVerticalNarrowTreeLayout new).
	makeMenu value: (MORadialTreeLayout new).
	makeMenu value: (MOSpringLayout new).
	makeMenu value: (MOSugiyamaLayout new).
	makeMenu value: (MOTreeLayout new).
	makeMenu value: (MOVerticalLineLayout new).
			
	"Define some nodes, edges and subviews."
	view
		nodes: (10 to: 70 by: 10)
		forEach: 
		[ 	:each | 
			view shape rectangle size: 20; withText.
			view nodes: ( each+1 to: each+9).

			view edge: each+1 from: each+1 to: each+2. 
			view edge: each+1 from: each+1 to: each+3. 
			view edge: each+1 from: each+1 to: each+4.
			view edge: each+2 from: each+2 to: each+5. 
			view edge: each+2 from: each+2 to: each+6. 
			view edge: each+2 from: each+2 to: each+7.
			view edge: each+3 from: each+3 to: each+7. 
			view edge: each+3 from: each+3 to: each+8. 
			view edge: each+3 from: each+3 to: each+9. 
			
			view circleLayout scaleBy: 6.
		].
	view circleLayout scaleBy: 25.
	
'! !

!MOEaselExamples methodsFor: 'software visualization' stamp: 'AlexandreBergel 12/4/2011 11:06'!
script6DepBetweenClasses
	<title: 'iHighlight dependencies between edges'>
	
^ 
'"Example on updating shape color. Moving the mouse about a node turn the edges to used classes red. "

| classes edges getDepOfAClass classesAndTheirOutgoingEdges |

"Return the list of classes that are dependent from aClass"
getDepOfAClass := [ :aClass |
	| b |
	b := Set new.
	aClass methods do: [:m | b addAll: ((m allLiterals select: [:l | (l isKindOf: Association) and: [ l value isBehavior ]]) collect: #value) ].
	b ].

"We select all the classes of Mondrian"
classes := (Smalltalk globals select: #isBehavior) select: [:c | c name beginsWith: ''MO'' ].
view shape rectangle width: #numberOfAttributes; height: #numberOfMethods.
view interaction action: #inspect.
view interaction
	on: MOMouseEnter do: [ :ann | 
		(classesAndTheirOutgoingEdges at: ann model) do: [:e | e copyShapeAndDo: [:s | s color: Color red ]].
		 ];
	on: MOMouseLeave do: [ :ann | 
		(classesAndTheirOutgoingEdges at: ann model) do: [:e | e copyShapeAndDo: [:s | s color: Color lightGray ]].
		 ].
view nodes: classes.
 
view shape: (MOOrthoVerticalLineShape new color: Color black).
edges := view edgesFrom: #superclass.
view treeLayout userDefinedEdges: edges.

view shape line color: Color veryLightGray.

classesAndTheirOutgoingEdges := Dictionary new.
classes do: [:cls |
	classesAndTheirOutgoingEdges at: cls put: (view edge: cls from: #yourself toAll:  [:c | getDepOfAClass value: c ])
].
'! !

!MOEaselExamples methodsFor: 'basic' stamp: 'Alexandre Bergel 2/28/2010 22:08'!
script6EdgesToAll
	<title: 'edgesToAll:'>
	^
'
"link 1 to 2,3,4, link 2 to 3,4,5, ..."
view nodes: (1 to: 20).
view edgesToAll: [:v | {v + 1 . v + 2. v + 3}].
view treeLayout'! !

!MOEaselExamples methodsFor: 'shape' stamp: 'AlexandreBergel 12/30/2010 10:27'!
script6MOArrowedOrthoHorizontalLineShape
	<title: 'Arrowed ortho horizontal line shape'>
	
^ 'view shape rectangle size: 30.
view nodes: Collection withAllSubclasses.
view shape: (MOArrowedOrthoHorizontalLineShape new).
view edgesFrom: #superclass.
view bulletTreeLayout horizontalGap: 80.  '! !

!MOEaselExamples methodsFor: 'layout' stamp: 'AlexandreBergel 12/29/2010 18:35'!
script6TreeLayout
	<title: 'tree layout'>
	
	^'view nodes: Collection withAllSubclasses.
view edgesFrom: #superclass.
view treeLayout
 '! !

!MOEaselExamples methodsFor: 'shape' stamp: 'AlexandreBergel 1/7/2011 15:05'!
script7AttachPoint
	<title: 'Particularizing attach points'>
	
^ '"Particularizing attach points"

view node: ''topCenter'' forIt: [
	view shape rectangle withText; size: 30.
	view nodes: (1 to: 3).
	view shape line toPositions: #(#topCenter); fromPositions: #(#topCenter) .
	view edges: {1 -> 2 . 2 -> 3 } from: #key to: #value fromGlobal: false toGlobal: false.
	view horizontalLineLayout ].

view node: ''topCenter'' forIt: [
	view shape rectangle withText; size: 30.
	view nodes: (1 to: 3).
	view shape line toPositions: #(#topCenter); fromPositions: #(#bottomCenter) .
	view edges: {1 -> 2 . 2 -> 3 } from: #key to: #value fromGlobal: false toGlobal: false.

	view horizontalLineLayout ].

view node: ''topCenter'' forIt: [
	view shape rectangle withText; size: 30.
	view nodes: (1 to: 3).
	view shape line toPositions: #(#bottomCenter); fromPositions: #(#bottomCenter) .
	view edges: {1 -> 2 . 2 -> 3 } from: #key to: #value fromGlobal: false toGlobal: false.

	view horizontalLineLayout ].'! !

!MOEaselExamples methodsFor: 'layout' stamp: 'AlexandreBergel 12/29/2010 18:35'!
script7BulletTreeLayout
	<title: 'bullet tree layout'>
	
	^'view nodes: Collection withAllSubclasses.
view edgesFrom: #superclass.
view bulletTreeLayout
 '! !

!MOEaselExamples methodsFor: 'basic' stamp: 'AlexandreBergel 9/16/2010 19:10'!
script7DashedEdge
	<title: 'Dashed edges'>
	^
'"The default line shape is a plain straight line. Lines may be dashed as well."

view shape rectangle size: 15.
view nodes: (1 to: 5).
view shape arrowedDashedLine width: 3.
view edges: {1 -> 2} from: #key to: #value.

view shape dashedLine.
view edges: {2 -> 3} from: #key to: #value.

view shape dashedLine dashLengths: {5 . 2}; width: 4.
view edges: {2 -> 4} from: #key to: #value.

view treeLayout'! !

!MOEaselExamples methodsFor: 'layout' stamp: 'AlexandreBergel 4/15/2011 12:13'!
script7FlowLayout
	<title: 'Flow layout'>
	
	^'| packages classes |
packages := {''Compiler'' . ''Finder'' .''File'' . ''Network-Kernel'' . ''Collections-Abstract''}.
packages do: [ :pakName |
	classes := (PackageInfo named: pakName) classes.
	view node: pakName forIt: [ 
		view shape rectangle size: [ :cls | cls methods size ].
		view nodes: classes. view bottomFlowLayout maxWidth: 200 ].
].
view flowLayout maxWidth: 500..
'! !

!MOEaselExamples methodsFor: 'basic' stamp: 'AlexandreBergel 10/3/2011 11:02'!
script8EdgeBetweenNodes
	<title: 'Edge between direct node'>
	^
'| nodes |
nodes := view nodes: #(1 2).
view addEdgeFromNode: nodes first toNode: nodes second.
'! !

!MOEaselExamples methodsFor: 'shape' stamp: 'AlexandreBergel 4/28/2011 09:51'!
script8SplineLine
	<title: 'Spline lines'>
	
^ '
"Example of spline line. Take care that spline lines are expensive to compute. To not abuse them :-)"
view shape rectangle size: 30.
view nodes: MOShape withAllSubclasses.
view shape splineLine.
view edgesFrom: #superclass.
view treeLayout 
'! !

!MOEaselExamples methodsFor: 'layout' stamp: 'AlexandreBergel 12/29/2010 19:19'!
script8Sugiyama
	<title: 'Sugiyama tree layout'>
	
	^'view nodes: Collection withAllSubclasses.
view edgesFrom: #superclass.
view sugiyamaLayout
 '! !

!MOEaselExamples methodsFor: 'shape' stamp: 'AlexandreBergel 10/4/2011 08:53'!
script9ConditionalOnLine
	<title: 'Condition on lines'>
	
^ 'view shape rectangle size: 10.
view nodes: (1 to: 10).

view shape line 
	if: [:v | v > 2 ] color: Color blue;
	if: [:v | v > 2 ] width: 10.
view edgesTo: [ :v | v * 2 ]
'! !

!MOEaselExamples methodsFor: 'layout' stamp: 'AlexandreBergel 2/21/2011 13:42'!
script9Layout
	<title: 'FADE Spring Layout'>
	
	^'"FADE is a force directly algorithm (also called spring algorithm or spring layout) invented by Aaron Quigley (http://www.cs.st-andrews.ac.uk/~aquigley/?Research:Past_Projects:FADE). FADE is faster than MOForceBasedLayout when more than 350 edges and 350 nodes have to be layouted. "

view shape rectangle withText.
view nodes: Collection withAllSubclasses.
view edgesFrom: #superclass.
view fadeLayout'! !

!MOExamples classSide methodsFor: 'public' stamp: 'AlexandreBergel 9/16/2010 18:06'!
populateMenu: menuMorph forEasel: easel
	"Return a menu filled with mondrian easel commands"

	| selectors title pragma help submenus aSubmenu |

	submenus := Dictionary new.

	help := self new.
	self organization categories do: [:catName |
		selectors := self organization listAtCategoryNamed: catName.
		selectors do: [:sel | 
			title := sel asString.
			pragma := ((self >> sel) pragmaAt: #title:).
			pragma ifNotNil: [ title := pragma arguments first ].
			
			aSubmenu := submenus at: catName asString ifAbsentPut: [ MenuMorph new ].
			aSubmenu add:  title target: easel selector: #setScript: argument: (help perform: sel) ].
	].

	submenus associationsDo: [ :ass | 
		menuMorph add: ass key subMenu: ass value ]
! !

Object subclass: #MOMatrixRenderer
	instanceVariableNames: 'rows columns cellFunction cellSize cellPadding cellShape'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Example'!

!MOMatrixRenderer methodsFor: 'accessing' stamp: 'simon.denier 11/4/2009 13:57'!
cellFunction
	^ cellFunction! !

!MOMatrixRenderer methodsFor: 'accessing' stamp: 'simon.denier 11/4/2009 13:57'!
cellFunction: anObject
	cellFunction := anObject! !

!MOMatrixRenderer methodsFor: 'drawing' stamp: 'Alexandre Bergel 3/2/2010 14:12'!
cellNodeIn: aViewRenderer row: rowElem column: colElem

	| cellObj n |
	cellObj := self cellFunction valueWithArguments: {rowElem. colElem}.
	^ cellObj
		ifNil: [
			aViewRenderer node: #nil using: self enclosingShape ]
		ifNotNil: [
			n := aViewRenderer node: #cell using: (self enclosingShape) forIt: [
				aViewRenderer shape: self cellShape.
				aViewRenderer node: cellObj.
			aViewRenderer layout: (MOHorizontalLineLayout new gapSize: (self cellPadding // 2)).
			n ]]! !

!MOMatrixRenderer methodsFor: 'accessing' stamp: 'simon.denier 11/4/2009 16:18'!
cellPadding
	^ cellPadding! !

!MOMatrixRenderer methodsFor: 'accessing' stamp: 'simon.denier 11/4/2009 16:18'!
cellPadding: anObject
	cellPadding := anObject! !

!MOMatrixRenderer methodsFor: 'accessing' stamp: 'simon.denier 11/4/2009 16:20'!
cellShape
	^ cellShape size: cellSize! !

!MOMatrixRenderer methodsFor: 'accessing' stamp: 'simon.denier 11/4/2009 15:12'!
cellShape: anObject
	cellShape := anObject! !

!MOMatrixRenderer methodsFor: 'accessing' stamp: 'simon.denier 11/4/2009 14:06'!
cellSize
	^ cellSize! !

!MOMatrixRenderer methodsFor: 'accessing' stamp: 'simon.denier 11/4/2009 14:06'!
cellSize: anObject
	cellSize := anObject! !

!MOMatrixRenderer methodsFor: 'accessing' stamp: 'simon.denier 11/4/2009 13:57'!
columns
	^ columns! !

!MOMatrixRenderer methodsFor: 'accessing' stamp: 'simon.denier 11/4/2009 13:57'!
columns: anObject
	columns := anObject! !

!MOMatrixRenderer methodsFor: 'drawing' stamp: 'simon.denier 11/4/2009 16:19'!
enclosingShape
	^ MOFixedRectangleShape new
			borderColor: Color lightGray;
			size: cellSize + cellPadding! !

!MOMatrixRenderer methodsFor: 'initialize-release' stamp: 'Alexandre Bergel 3/2/2010 14:14'!
initialize 

	super initialize.
	cellSize := 20.
	cellPadding := 10.
	cellFunction := [:rowEl :colEl | {rowEl. colEl}].
	cellShape := MOFixedRectangleShape new borderColor: Color white; fillColor: Color black.! !

!MOMatrixRenderer methodsFor: 'drawing' stamp: 'simon.denier 11/4/2009 13:56'!
render

	| view |
	view := MOViewRenderer new.
	self renderOn: view.
	view open! !

!MOMatrixRenderer methodsFor: 'drawing' stamp: 'AlexandreBergel 12/30/2010 09:44'!
renderOn: aViewRenderer 
	| builder x y |
	
	self assert: [ self columns notNil ] description: [ 'Rows cannot be nil. Use #columns: with a collection' ].
	self assert: [ self rows notNil ] description: [ 'Rows cannot be nil. Use #rows: with a collection' ].
	

	builder := MOFormsBuilder new.
	self rows size + 1 timesRepeat: [ builder row; pref ].
	self columns size + 1 timesRepeat: [ builder column; pref ].

	aViewRenderer shape: (self enclosingShape text: [ :el | el asString ]).
	builder x: 1 	y: 1 add: (aViewRenderer node: #matrix using: self enclosingShape).
	
	x := 1. y := 1.
	columns do: 
		[ :colElem | 
		x := x + 1.
		aViewRenderer shape: (self enclosingShape text: [ :el | el asString ]).
		builder 
			x: x
			y: y
			add: (aViewRenderer node: colElem) ].

	x := 1. y := 1.
	rows do: 
		[ :rowElem | 
		y := y + 1.
		aViewRenderer shape: (self enclosingShape text: [ :el | el asString ]).
		builder 
			x: x
			y: y
			add: (aViewRenderer node: rowElem) ].
	
	y := 1.
	rows do: 
		[ :rowElem | 
		y := y + 1.
		x := 1. 
		columns do: 
			[ :colElem | 
			x := x + 1.
			builder 
				x: x
				y: y
				add: (self cellNodeIn: aViewRenderer row: rowElem column: colElem) ]].
	aViewRenderer layout: builder asLayout.
! !

!MOMatrixRenderer methodsFor: 'accessing' stamp: 'simon.denier 11/4/2009 13:57'!
rows
	^ rows! !

!MOMatrixRenderer methodsFor: 'accessing' stamp: 'simon.denier 11/4/2009 13:57'!
rows: anObject
	rows := anObject! !

!MOMatrixRenderer methodsFor: 'example' stamp: 'AlexandreBergel 4/21/2011 09:56'!
sampleDeadlock
	"
	self new sampleDeadlock
	"
	
	| acq |
	self cellSize: 40.
	self cellPadding: 20.
	self cellShape fillColor: [:cell ||lock|
			lock := cell second.
			(#(lock2 lock3) includes: lock)
				ifTrue: [Color red]
				ifFalse: [Color black]].
	self columns: #(lock1 lock2 lock3 lock4).
	self rows: #(thread1 thread2 thread3 thread4 thread5).
	acq := #(	(thread1 lock1)
				(thread2 lock1)
				(thread3 lock2) (thread3 lock3)
				(thread4 lock2) (thread4 lock3)
				(thread5 lock2) (thread5 lock4)).
	self cellFunction: [:row :col | |tuples|
		tuples := (acq select: [:tuple| tuple first = row]).
		tuples detect: [:tup| tup second = col]	ifNone: [nil] ].
	^ self render! !

TestCase subclass: #DistributionMapExampleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Example-Tests'!

!DistributionMapExampleTest classSide methodsFor: 'history' stamp: 'BenComan 6/10/2012 00:10'!
lastStoredRun
	^ ((Dictionary new) add: (#errors->((Set new))); add: (#passed->((Set new) add: #testSample; yourself)); add: (#failures->((Set new))); add: (#timeStamp->(DateAndTime basicNew instVarAt: 1 put: 623; instVarAt: 2 put: (Duration seconds: 28800 nanoSeconds: 0); instVarAt: 3 put: 2456089; instVarAt: 4 put: 919000001; yourself)); yourself)! !

!DistributionMapExampleTest methodsFor: 'tests' stamp: 'AlexandreBergel 12/30/2010 10:07'!
testSample
	
	| viewRenderer |
	viewRenderer := (DistributionMapExample new properties: DistributionMapExample sampleProperties;
				propertiesMap: DistributionMapExample sampleMap;
				propertyBlock: DistributionMapExample sampleBlock;
				elements: DistributionMapExample sampleOrderedElements;
				render: Collection withAllSubclasses).
				
	self assert: (viewRenderer class == MOViewRenderer).
	viewRenderer getRenderedForm! !

TestCase subclass: #MOMatrixRendererTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Example-Tests'!

!MOMatrixRendererTest classSide methodsFor: 'history' stamp: 'BenComan 6/10/2012 00:10'!
lastStoredRun
	^ ((Dictionary new) add: (#errors->((Set new))); add: (#passed->((Set new) add: #testSampleDeadlock; add: #testRendering; yourself)); add: (#failures->((Set new))); add: (#timeStamp->(DateAndTime basicNew instVarAt: 1 put: 623; instVarAt: 2 put: (Duration seconds: 28800 nanoSeconds: 0); instVarAt: 3 put: 2456089; instVarAt: 4 put: 916000001; yourself)); yourself)! !

!MOMatrixRendererTest methodsFor: 'utils' stamp: 'AlexandreBergel 4/21/2011 09:57'!
getAllWindows
	^ World submorphs select: #isSystemWindow! !

!MOMatrixRendererTest methodsFor: 'tests' stamp: 'AlexandreBergel 12/30/2010 10:01'!
testRendering

	| matrix view |
	view := MOViewRenderer new.
	matrix := MOMatrixRenderer new.
	matrix cellShape 
			text: [ :v1 :v2 | v1 * v2];
			fillColor: Color lightBlue.
	matrix columns: #(1 2 3).
	matrix rows: #(4 5 6 7 8).
	matrix renderOn: view.! !

!MOMatrixRendererTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/21/2011 09:58'!
testSampleDeadlock
	| windows |
	
	windows := self getAllWindows.
	[ MOMatrixRenderer new sampleDeadlock] ensure: [
		(self getAllWindows copyWithoutAll: windows) do: #delete  
	].
	! !
